// 
// quix-interface
// (c) 1997 geisler@primus.baynet.de
// (c) 1997 biber@rz.fh-augsburg.de
//

#include<stdio.h>
#include<string.h>
#include"quixernet.c"
#include"quixer.h"

//
// Scan file CONFIGFILE (default /etc/quixer.conf)
// setup quixer
// purpose: shorten email-adress
// e.g. geisler@rz.fh-augsburg.de becomes mg
// and get quix-number to send message to
//

char *scan_known_senders(char *from,char *to,char *subject)
{
  int default_rule=0;
  FILE *fp;
  FILE *fp2;
  char tmp_line[PAGERLINESIZE];
  char *n_email=NULL;                     // normal email address
  char *s_email=NULL;                     // shorten email address
  char *t_email=NULL;                     // to email address
  char *number=NULL;                      // quix-number
  char *carrier=NULL;			  // carrier e.g. quix/d2/d1
  int i=0;
  int j=0;
  int shorter=0;
  int global=0;
  
  if (!(fp=fopen(CONFIGFILE,"r"))) 
  { 
    printf("error while opening %s\n",tmp_line);
    exit(0);
  };

  if (!(fp2=fopen(LOGFILE,"a")))
  {
    printf("error while opening %s\n",tmp_line);
    exit(0);
  };

  while(fgets(tmp_line,sizeof(tmp_line),fp) && *tmp_line != '\n') 
  {
    if(*tmp_line=='G')
    {
      if (!strncmp(tmp_line, "GLOBAL-SECTION", 14))
      {
        global=1;
        shorter=0;
        fgets(tmp_line,sizeof(tmp_line),fp); 
      };
    };    
    if(*tmp_line=='K')
    {
      if (!strncmp(tmp_line, "KNOWN-SECTION", 13))
      {
        shorter=1;
        global=0;
        fgets(tmp_line,sizeof(tmp_line),fp);
      };
    };

    if((*tmp_line!='#') && (global))
    {
      i=0;
      j=0;

      // to_adress
      while((tmp_line[i]!=' ') && (tmp_line[i]!='\t')) i++;
      tmp_line[i]='\0';
      t_email=strdup(tmp_line);
      i++;
      while((tmp_line[i]==' ') || (tmp_line[i]=='\t')) i++;
      j=i;

      // number
      while((tmp_line[i]!=' ') && (tmp_line[i]!='\t')) i++;
      tmp_line[i]='\0';
      number=strdup(&tmp_line[j]);
      i++;
      while((tmp_line[i]==' ') || (tmp_line[i]=='\t')) i++;
      j=i;

      // carrier
      while((tmp_line[i]!=' ') && (tmp_line[i]!='\t') && (tmp_line[i]!='\n')) i++;
      tmp_line[i]='\0';
      carrier=strdup(&tmp_line[j]);

      if(!strcmp(t_email,to))
      {
        fprintf(fp2,"FOUND: |%s| belongs to nr.: |%s| carrier: |%s|\n",t_email,number,carrier);
        global=0;
      }
      else
      {
        number=NULL;
      };
    };

    if((*tmp_line!='#') && (shorter))
    {
      i=0;
      j=0;

      // n_email
      while((tmp_line[i]!=' ') && (tmp_line[i]!='\t')) i++;
      tmp_line[i]='\0';
      n_email=strdup(tmp_line);
      i++;
      while((tmp_line[i]==' ') || (tmp_line[i]=='\t')) i++;
      j=i;

      // nick
      while((tmp_line[i]!=' ') && (tmp_line[i]!='\t')) i++;
      tmp_line[i]='\0';
      s_email=strdup(&tmp_line[j]);
      i++;
      while((tmp_line[i]==' ') || (tmp_line[i]=='\t')) i++;
      j=i;

#ifdef DEBUG
printf("n_email: |%s|\n",n_email);
#endif

      // default-rule
      if(!strcmp(n_email,"default"))
      {
	if(tmp_line[i]=='y')
        {
          fprintf(fp2,"default-rule set to 'y' (send all received emails)\n");
          default_rule=1;
        }
        else
        {
          fprintf(fp2,"default-rule set to 'n' (send only specified emails)\n");
          default_rule=0;
        };
      };
      // send message (y/n)
      if(!strcmp(n_email,from)) 
      { 
        if((tmp_line[i]=='y') && (number))
        {
          if(!strcmp(carrier,"quix"))
          {
            sprintf(tmp_line,"danke=%%2FQUIX%%2FDANKE.HTM&nr=%s&subject=%s+-+%s",number,s_email,subject); 
            s_email=strdup(tmp_line);
            fprintf(fp2,"FINAL-WEB-STRING: |%s|\n",s_email);
            send_message(s_email,carrier);
            return s_email; 
          }
          else
          if(!strcmp(carrier,"D1"))
          {
            sprintf(tmp_line,"GET http://ncs.tiss.com/cgi-bin/sendsms?serial=3334&error=http%%3A%%2F%%2Fwww.nokia-shop.de%%2Fsmser.htm&next=http%%3A%%2F%%2Fwww.nokia-shop.de%%2Fsmsok.htm&network=%s&target=%s&text=%s+-+%s&cemail=&validity=0 HTTP/1.0",carrier,number,s_email,subject); 
            printf("%s",tmp_line);
            s_email=strdup(tmp_line);
            fprintf(fp2,"FINAL-WEB-STRING: |%s|\n",s_email);
            send_message(s_email,carrier);
            return s_email; 
	  }
          else
          if(!strcmp(carrier,"D2"))
          {
            sprintf(tmp_line,"GET http://ncs.tiss.com/cgi-bin/sendsms?serial=3334&error=http%%3A%%2F%%2Fwww.nokia-shop.de%%2Fsmser.htm&next=http%%3A%%2F%%2Fwww.nokia-shop.de%%2Fsmsok.htm&network=%s&target=%s&text=%s+-+%s&cemail=&validity=0 HTTP/1.0",carrier,number,s_email,subject); 
            printf("%s",tmp_line);
            s_email=strdup(tmp_line);
            fprintf(fp2,"FINAL-WEB-STRING: |%s|\n",s_email);
            send_message(s_email,carrier);
            return s_email;             
	  }
        }
        else
        {
          fprintf(fp2,"SEND-MESSAGE: either no number is found or 'n' ist specified\n",s_email);
          return NULL;
        };
      };
    };
  };
  if (number)
  { 
    return NULL;
  }
  else
  {
    return NULL;
  };
};

//
// get mailheader
// cut email-from-adress and subject
//

char *get_mailheader()
{
  FILE *fp2;
  char line[LINESIZE];
  char *tmp;
  char *from;
  char *to;
  char *s_from;
  char *subject;

  fp2=fopen(LOGFILE,"a");

  // scan email-header
  while(fgets(line,sizeof(line),stdin) && *line != '\n')
  {
    switch(*line)
    {
      case 'F' :
      {
        if (!strncmp(line, "From: ", 6))
        {
          if (tmp = index(line, '>')) 
          {         
            *tmp = '\0';                       
            tmp = index(line, '<') + 1;          
            from=strdup(tmp);
          }
          else 
          {                              
            for (tmp = line + 6; *tmp && *tmp != ' '; ++tmp);
            *tmp = '\0';
            tmp = line + 6;                    
            from=strdup(tmp);
          };
          fprintf(fp2,"eMail FROM: |%s|\n",from);
        };
      };
      case 'T' :
      {
        if (!strncmp(line, "To: ", 4))
        {
          if (tmp = index(line, '>')) 
          {         
            *tmp = '\0';                       
            tmp = index(line, '<')+1;          
            to=strdup(tmp);
          }
          else 
          {                              
            for (tmp = line + 4; *tmp && *tmp != ' '; ++tmp);
            *(tmp-1) = '\0';
            tmp = line + 4;                    
            to=strdup(tmp);
          };
          fprintf(fp2,"was sent TO: |%s|\n",to);
        };
      };
      case 'S' :
      {
        if (!strncmp(line, "Subject: ",9))
        {
          tmp=&line[9];
          tmp[strlen(tmp)-1]='\0';
          subject=strdup(tmp);
          fprintf(fp2,"with SUBJECT: |%s|\n",subject);
          fprintf(fp2,"--------------------------------------------\n");
        };
      };
    };
  };
  if (scan_known_senders(from,to,subject))
  {
//    sprintf(line,"%s",s_from);
  }
  else 
  {
    fprintf(fp2,"ERROR - no message has been send!\n");
    fprintf(fp2,"--------------------------------------------\n");
    exit(0);
  };
};

// 
// send message to specified server and port
//

send_message(char *message,char *carrier)
{
  char linebuffer[515];
  int i;

  if(!strcmp(carrier,"quix"))
  {
    i=net_connect(80,QUIX_HOST);
    net_sendline(i,"POST /cgi-bin/quixmail HTTP/1.0\n");
    net_sendline(i,"User-Agent: Mozilla/3.01Gold (X11; I; SunOS 5.5 sun4m)\n");
    net_sendline(i,"Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*\n");
    net_sendline(i,"Content-type: application/x-www-form-urlencoded\n");
    sprintf(linebuffer,"Content-length: %i\n",strlen(message));
    net_sendline(i,linebuffer);
    net_sendline(i,"Host: www.o-tel-o.de\n");
    net_sendline(i,"Referer: http://www.o-tel-o.de/quix.html\n\n");
    net_sendline(i,message);
    net_sendline(i,"\n");
  }
  else
  if(!strcmp(carrier,"D1"))
  {
    i=net_connect(80,D1_HOST);
    net_sendline(i,message);
    net_sendline(i,"\n");
    net_sendline(i,"Referer: http://WWW.NOKIA-SHOP.DE/sms.htm\n");
    net_sendline(i,"Proxy-Connection: Keep-Alive\n");
    net_sendline(i,"User-Agent: Mozilla/4.03 [en] (X11; I; Linux 2.1.63 CrayII)\n");
    net_sendline(i,"Host: ncs.tiss.com\n");
    net_sendline(i,"Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*\n");
    net_sendline(i,"Accept-Language: de\n");
    net_sendline(i,"Accept-Charset: iso-8859-1,*,utf-8\n");
    net_sendline(i,"\n");
  }
  else 
  if(!strcmp(carrier,"D2"))
  {
    i=net_connect(80,D2_HOST);
    net_sendline(i,message);
    net_sendline(i,"\n");
    net_sendline(i,"Referer: http://WWW.NOKIA-SHOP.DE/sms.htm\n");
    net_sendline(i,"Proxy-Connection: Keep-Alive\n");
    net_sendline(i,"User-Agent: Mozilla/4.03 [en] (X11; I; Linux 2.1.63 CrayII)\n");
    net_sendline(i,"Host: ncs.tiss.com\n");
    net_sendline(i,"Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*\n");
    net_sendline(i,"Accept-Language: de\n");
    net_sendline(i,"Accept-Charset: iso-8859-1,*,utf-8\n");
    net_sendline(i,"\n");
  }; 

  while(net_getline(i,linebuffer,515))
  {
#ifdef DEBUG
    printf("%s\n",linebuffer);
#endif
  };
};

// 
// Main
//

main(int argc,char *argv[])
{
   char *tmp;
   strdup(get_mailheader());
   exit(0);
};
