//
// quixer - socket side
//

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <errno.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>

//
// open new socket to port x 
//

int net_connect(int port,const char *buf)
{
	struct sockaddr_in myaddress;
	struct hostent *host;
	int sockfd;

	host=gethostbyname(buf);
	if(host==NULL) return(0);

	myaddress.sin_family=host->h_addrtype;
	myaddress.sin_addr.s_addr=*((long *)host->h_addr);
	myaddress.sin_port=htons(port);

	sockfd=socket(AF_INET,SOCK_STREAM,0);
	if(sockfd==-1) return(0);

	if(connect(sockfd,(struct sockaddr *)&myaddress,sizeof(myaddress))<0)
	{
		close(sockfd);
		return(0);
	}
	return(sockfd);
}

//
// send string to port       
//

int net_sendline(int sockfd,const char *buf)
{
  if(write(sockfd,buf,strlen(buf))!=strlen(buf))
  {
    return(0);
  }
  else return(1);
}

//
// receive string from port  
//

int net_getline(int sockfd,char *buf,int len)
{
  int i=0;

  while (i!=len)
  {
    if (read(sockfd,&buf[i],1)!=1) return(0);

    if (buf[i]=='\n')
    {
      if (i>0 && buf[i-1]=='\r') buf[i-1]=0; else buf[i]=0;
      return(1);
    }
  i++;
  }
}

